<%@ page import="java.util.*" %>
<%@ page import="java.io.*" %>
<%@ page import="com.sas.oprisk.server.*" %>
<%@ page import="com.sas.solutions.cpb.runtime.*" %>
<%@ page import="com.sas.solutions.cpb.screendefs.*" %>
<%@ page import="com.sas.solutions.cpb.screendefs.xml.validator.*" %>
<%@ page import="com.sas.oprisk.monitor.web.cpb.runtime.*" %>
<%@ page import="org.apache.struts.util.LabelValueBean" %>
<%@ page import="com.sas.oprisk.monitor.web.opriskevent.actions.EventFormPageModel" %>
<%@ page import="com.sas.oprisk.server.ApplicationProperties" %>
<%@ page import="com.sas.oprisk.server.workflow.WorkflowStatusBean" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.server.workflow.WorkflowUtil" %>
<%@ include file="/tiles/taglibs.jsp" %>
<%
   final Locale locale = request.getLocale();
   final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final EventFormPageModel model = (EventFormPageModel)request.getAttribute("model");
   final boolean readOnly = model.getReadOnly().booleanValue();
   final boolean isWorkflowConfigured = WorkflowUtil.isIncidentWorkflowConfigured();
   final boolean isFresh = (model.getEvent() != null && model.getEvent().isFresh()) ? true : false;
%>
<mon:Page template="details">

<mon:Head>

   <mon:include js="/script/checkboxRadioUtil.js" />
   
   <script type="text/javascript">
   function doIncident(method, anchor) {
      var f = document.forms[0];
      f.action = "<%= request.getContextPath() %>/NewIncident.do"
         + "?method=" + method;
         
      if (anchor) {
         f.action = f.action + "#" + anchor;
      }
         
      f.submit();
   }
   
   function doSave() {
      var f = document.forms[0];
      f.action = "<%= request.getContextPath() %>/SaveNewIncident.do?method=save";
      f.submit();
   }
   
   function doWorkflowStatus(actionId, workflowActivityId, workflowStatusId, msg) {
      var doIt = true;  

      if (msg != "") {
         if (!confirm(unescape(msg))) {
            unLockCommandButtons();
            doIt = false;
         }
      }

      if (doIt) {
         // show the "Please Wait" dialog (if configured)
         beginWait();
         
         var f = document.forms[0]; 
         f.action = "<%= request.getContextPath() %>/NewIncident.do?method=doWorkflow&action=" + actionId
                   + "&<%= WorkflowWebUtil.PARAM_WORKFLOW_ACTIVITY_ID %>=" + workflowActivityId
                   + "&<%= WorkflowWebUtil.PARAM_WORKFLOW_STATUS_ID %>=" + workflowStatusId;
         f.submit();
      }
   }
   
   function forward(path, refreshMethod, anchor) {
      var method = "forward" + "&path=" + escape(path);
      if (refreshMethod) {
         method += "&rm=" + refreshMethod;
      }
     
      doIncident(method, anchor);
   }
   
   function viewIncident(handle)
   {
      forward("/NewIncident.do?method=acceptIncident&handle=" + handle);
   }
   
   addLoadEvent(setFocus);
   </script>
   
</mon:Head>

<mon:Body>
   
   <html:form action="/NewIncident" onsubmit="doSave(); return false;">
   
   <mon:ToolBar>
<%
   if (model.getReadOnly().booleanValue())
   {
%>
      <mon:Button onclick="doIncident('cancel')" type="submit">
         <fmt:message key='application.button.done.txt' />
      </mon:Button>
<%
   }
   else
   {
%>
<%-- saveSubmit and cancel buttons --%>
      <!--
      <mon:Button type="submit">
         <fmt:message key='incident.button.saveAndSubmitForInvestigation.txt' />
      </mon:Button>
      -->
         <mon:Button 
                onclick="doIncident('save')"><fmt:message key='saveButton.txt' /></mon:Button>
         <mon:Button 
                onclick="doIncident('apply')" ><fmt:message key='application.button.apply.txt' /></mon:Button>        

      <% if (isWorkflowConfigured) { %>
         <c:forEach var="action" items="${workflowStatuses}" varStatus="status">
            <%
               WorkflowStatusBean actionBean = (WorkflowStatusBean)pageContext.getAttribute("action");
               String confirmMsg = actionBean.getConfirmation();
               if (actionBean.getActionId() != null && actionBean.getActionId().equalsIgnoreCase("Delete") && !ConfigDataProperties.isChangeReasonRequired()){
                  confirmMsg = model.getDeleteConfirmationMessage(request, psession);
                  actionBean.setConfirmation(confirmMsg);
               }
            %>
            <mon:Button name="actionButton${status.count}" onclick="lockCommandButtons(); beginWait(); doWorkflowStatus('${action.actionId}', '${action.activityId}', '${action.statusId}', '${action.confirmation}')">
               <c:out value="${action.name}"/>
            </mon:Button>
         </c:forEach>
      <% } else { %>
         <mon:Button onclick="lockCommandButtons(); beginWait(); doIncident('submitForInvestigation')">
            <fmt:message key='incident.workflow.status.submitForInvestigation.txt' />
         </mon:Button>
         
         <% if (!isFresh) { %>
            <mon:Button onclick="lockCommandButtons(); beginWait(); doIncident('delete')">
               <fmt:message key='incident.workflow.status.delete.txt' />
            </mon:Button>
         <% } %>
      <% } %>
      
      <mon:Button onclick="doIncident('cancel')">
         <fmt:message key='cancelButton.txt' />
      </mon:Button>
<%
   }
%>
   </mon:ToolBar>
   
   <mon:Content>
   
      <input type="hidden" name="handle" value="<%=model.getEvent().getHandle()%>" />
      <html:hidden property="opRiskEventRk" />
      <html:hidden property="eventTypeCd" />
      <html:hidden property="threshold" />
      <html:hidden property="draftFlg" />
      <html:hidden property="validationStateCd" />
      <html:hidden property="enteredOnDt" />
      <html:hidden property="maxPotentialAmtCurrCd" />
      
      <cpb:screen screenID="${newIncidentForm.screenId}" readOnly="<%= readOnly %>" />

   </mon:Content>
   
   </html:form>
   
</mon:Body>

</mon:Page>