<%@ page import="java.util.*" %>
<%@ page import="java.io.*" %>
<%@ page import="com.sas.oprisk.server.*" %>
<%@ page import="com.sas.solutions.cpb.runtime.*" %>
<%@ page import="com.sas.solutions.cpb.screendefs.*" %>
<%@ page import="com.sas.solutions.cpb.screendefs.xml.validator.*" %>
<%@ page import="com.sas.oprisk.monitor.web.cpb.runtime.*" %>
<%@ page import="org.apache.struts.util.LabelValueBean" %>
<%@ page import="com.sas.oprisk.monitor.web.opriskevent.actions.EventFormPageModel" %>
<%@ page import="com.sas.oprisk.server.ApplicationProperties" %>
<%@ page import="com.sas.oprisk.monitor.web.MonitorContext" %>
<%@ page import="com.sas.oprisk.server.ConfigDataProperties" %>
<%@ page import="com.sas.oprisk.server.workflow.WorkflowUtil" %>
<%@ include file="/tiles/taglibs.jsp" %>
<%
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   MonitorContext mcontext = MonitorContext.getMonitorContext(request);
   java.util.Locale locale = request.getLocale();
   java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   boolean viewOnly = false;
   if (request.getAttribute("viewOnly") != null && ((Boolean)request.getAttribute("viewOnly")).booleanValue())
      viewOnly = true;
   boolean reject = false;
   if (request.getAttribute("reject") != null && ((Boolean)request.getAttribute("reject")).booleanValue())
      reject = true;
   final boolean multiUserUpdate = ConfigDataProperties.isincidentMultiuserUpdateEnable();
   EventFormPageModel model = (EventFormPageModel)request.getAttribute("model");
   String incidentStatus = "";
   if (model.getEvent() != null && model.getEvent().getIncidentStatus(psession) != null)
      incidentStatus = bundle.getString(model.getEvent().getIncidentStatus(psession).getDisplayNameKey());
   String creatorName = "";
   if (model.getEvent() != null && model.getEvent().getCreator(psession) != null)
      creatorName = model.getEvent().getCreator(psession).toString(locale, psession);
   String investigatorName = "";
   if (model.getEvent() != null && model.getEvent().getInvestigator(psession) != null)
      investigatorName = model.getEvent().getInvestigator(psession).toString(locale, psession);
   String incidentType = "";
   if (model.getEvent() != null && model.getEvent().getIncidentTypeCd() != null)
      incidentType = mcontext.getIncidentTypeDescription(model.getEvent().getIncidentTypeCd(), locale, psession);

   String customerComplaint = "";
   if (model.getEvent() != null && model.getEvent().getCustomerComplaintFlg() != null) {
      if (model.getEvent().getCustomerComplaintFlg().booleanValue())
         customerComplaint = bundle.getString("application.yes.txt");
      else         
         customerComplaint = bundle.getString("application.no.txt");
   }
   final boolean isWorkflowConfigured = WorkflowUtil.isIncidentWorkflowConfigured();
%>

<mon:Page template="details">
<%-- BEGIN PAGE --%>

   <mon:Head>
   <%-- BEGIN HEAD --%>
   <script type="text/javascript">
   function wizardInit() {
      // override wizardInit so that buttons are not disabled
   }
   
   function doIncident(method, anchor) {
      var f = document.forms[0];
      f.action = "<%= request.getContextPath() %>/NewIncident.do"
         + "?method=" + method;
         
      if (anchor) {
         f.action = f.action + "#" + anchor;
      }
         
      f.submit();
   }
   
   function doWorkflowStatus(method, actionId, workflowActivityId, workflowStatusId, msg) {
      var doIt = true;  

      if (msg != "") {
         if (!confirm(msg)) {
            unLockCommandButtons();
            doIt = false;
         }
      }

      if (doIt) {
         // show the "Please Wait" dialog (if configured)
         beginWait();
         
         var f = document.forms[0]; 
         f.action = "<%= request.getContextPath() %>/NewIncident.do?method=doWorkflow&action=" + actionId
                   + "&<%= WorkflowWebUtil.PARAM_WORKFLOW_ACTIVITY_ID %>=" + workflowActivityId
                   + "&<%= WorkflowWebUtil.PARAM_WORKFLOW_STATUS_ID %>=" + workflowStatusId;
         f.submit();
      }
   }
   
   function forward(path, refreshMethod, anchor) {
      var method = "forward" + "&path=" + escape(path);
      if (refreshMethod) {
         method += "&rm=" + refreshMethod;
      }
     
      doIncident(method, anchor);
   }
   function viewIncident(handle)
   {
      forward("/NewIncident.do?method=acceptIncident&handle=" + handle);
   }
   </script>
   <%-- END HEAD --%>
   </mon:Head>
   
   <mon:Body>
   <%-- BEGIN BODY --%>
      
      <html:form action="/NewIncident" >
      
      <mon:ToolBar>
      <%-- BEGIN TOOL BAR --%>
<% if (viewOnly) { %>

         <mon:Button onclick="doIncident('cancel')">
            <fmt:message key='application.button.done.txt' />
         </mon:Button>

<% } else { %>

      <% if (isWorkflowConfigured) { %>
         <c:forEach var="action" items="${workflowStatuses}" varStatus="status">   
            <mon:Button name="actionButton${status.count}" onclick="lockCommandButtons(); beginWait(); doWorkflowStatus('${action.name}', '${action.actionId}', '${action.activityId}', '${action.statusId}', '${action.confirmation}')">
               <c:out value="${action.name}"/>
            </mon:Button>
         </c:forEach>
      <% } else { %>
         <mon:Button onclick="doIncident('accept')">
            <fmt:message key='incident.button.accept.txt' />
         </mon:Button>

         <% if (!multiUserUpdate) { 
            if (reject) { %>
               <mon:Button onclick="doIncident('reject')">
                  <fmt:message key='application.button.reject.txt' />
               </mon:Button>
            <% } else { %>
               <mon:Button onclick="doIncident('reassign')">
                  <fmt:message key='application.button.reassign.txt' />
               </mon:Button>
      
            <% } %>
         <% } %>
      <% } %>

         <mon:Button onclick="doIncident('cancel')">
            <fmt:message key='cancelButton.txt' />
         </mon:Button>
      
<% } %>
      <%-- END TOOL BAR --%>
      </mon:ToolBar>
      
      <mon:Content>
      <%-- BEGIN CONTENT --%>
      
         <html:hidden property="handle" />
         <html:hidden property="opRiskEventRk" />
         <html:hidden property="eventTypeCd" />
         <html:hidden property="threshold" />
         <html:hidden property="draftFlg" />
         <html:hidden property="validationStateCd" />
         <html:hidden property="enteredOnDt" />
   
         <%-- render the screen --%>
         <cpb:screen screenID="${newIncidentForm.screenId}" readOnly="true" />

      <%-- END CONTENT --%>
      </mon:Content>
   
      </html:form>
      
   <%-- END BODY --%>
   </mon:Body>
   
<%-- END PAGE --%>
</mon:Page>

